Redmine - Feature #4052

Cross-project redmine links with alternate link text for source and export links.
2009-10-19 05:43 - William Baum

Status: New Start date: 2009-10-19
Priority: Normal Due date:

Assignee: % Done: 50%
Category: Text formatting Estimated time: 0.00 hour

Target version:

Resolution:

Description

In Feature #3346 (Support for cross-project revision links), James Wells and Babar O'Cap collaborated to make it possible to create
commit and revision links across projects.

| have now extended the project: syntax to source: and export: links and also extended them with the ability to specify alternate link
text: "Download filename" instead of projectname:export:foo/bar/path/filename.

| have also corrected the issue causing source and export links to not be properly converted to absolute links in issue update emails.
(See Defect #3483)

So... Source and export links now work in emails, can be cross project, and can have alternate display text for the link.
Syntax:

o ["Link alternate display title"=][project:]source:some/path[/file][@52][#L120]
¢ ["Link alternate display title"=][project:]Jexport:some/path/file[@52]

Note: For the link text, the double-quotes are currently required, even if the text is only one word. | chose to implement the
alternate link name functionality in a way that altered the primary regex as little as possible. It's getting a bit unwieldy.

091018-cross-project_redmine_links-tests.patch contains changes to test/* files as provided in:

e #3346 cross-project_revision_and_commit_links_v5.diff - Patch v5 - from Babar O'Cap, 2009-08-26 03:27

| have no idea how to use, extend, or test this test/* functionality, so | didn't attempt to..

091018-cross-project_redmine_links.patch contains no test/* file modifications.

Related issues:

Related to Redmine - Feature #779: Multiple SCM per project Closed 2008-03-04
Related to Redmine - Feature #7409: Cross project Redmine links Closed 2011-01-22
Related to Redmine - Feature #3346: Support for cross-project revision links Closed 2009-05-12
Related to Redmine - Defect #3483: Relative url for source links in notificat... Closed 2009-06-12
Related to Redmine - Feature #10248: Specific text instead of addresses to th... New

Related to Redmine - Feature #21443: Links to resources in Markdown New

Has duplicate Redmine - Feature #4667: Ability to link to a revision in a sub... Closed 2010-01-27
History

#1 - 2009-10-19 05:48 - William Baum

oops.. image links don't work for attachments.. that last part was supposed to be:

091018-cross-project_redmine_links-tests.patch contains changes to test/* files as provided in:

e #3346 cross-project_revision_and_commit_links_v5.diff - Patch v5 - from Babar O'Cap, 2009-08-26 03:27

| have no idea how to use, extend, or test this test/* functionality, so | didn't attempt to..
091018-cross-project_redmine_links.patch contains no test/* file modifications.

#2 - 2009-10-20 19:25 - William Baum

| have discovered an issue with this, which hopefully can be easily resolved...

This patch currently breaks the Iversion#6 syntax. Instead of being a link to the version in the roadmap, it becomes a link to an issue by that number (
#6).

#3 - 2009-10-22 02:59 - William Baum
- File 091021-cross-project_redmine_links.patch added
- % Done changed from 0 to 50

Updated patch file, corrects issues with attachment, document, and version links.

#4 - 2009-11-27 11:37 - Babar O'Cap

+1

#5 - 2010-03-26 11:58 - Alexey Palazhchenko

Any news?

#6 - 2010-03-29 00:47 - William Baum

- File 100328-_r3618_-cross-project_redmine_links.patch added
Here's an svn formatted patch against r3618.

It's functional, but could use some refactoring.

#7 - 2010-04-12 11:04 - Antonio Garcia-Dominguez

+1

#8 - 2010-07-01 09:31 - Pieter Smith

+1

This is so damn useful! Why has nobody added it to the roadmap yet!?

#9 - 2010-08-04 18:04 - Pieter Smith

Hi William,
Any chance that you can update the patch for redmine 0.9.6 or later?
Thanks in advance!

#10 - 2010-08-04 21:18 - Pieter Smith
O'h... | forgot to mention that | tried merging the patch with 0.9.6, but got more merge conflicts than | can safely solve with my limited Ruby

knowledge.

#11 - 2010-08-06 01:22 - William Baum
- File 100805-1.0.0_r3854-cross-project_redmine_links.patch added

My apologies.. | actually started to do this weeks ago and got pulled off on something else..

Attached is 100805-1.0.0_r3854-cross-project_redmine_links.patch, which is a patch against 1.0.0 (source:/trunk@3854).

| did actually generate patches against 0.9.5 (source:/trunk@3815) and 0.9.6 (source:/trunk@3815) as well, but I'm not uploading them because they
are identical except for the revision references in the patch. This patch should apply without issue against any trunk or release between r3602 and
r3894.

The functional changes in this patch are all in app/helpers/application_helper.rb, which has had a couple of recent revisions that would affect line
numbers, but the patch should still apply properly to a current trunk. Let me know if you need a patch against a more recent trunk..

#12 - 2010-08-06 14:25 - Pieter Smith
- File 100806-0.9.6_add_cross_project_links_with_changesets.patch added

Thanks. Can't we get a Target Version for this? How can we convince the core team to integrate this?
| am also adding 100806-0.9.6_add_cross_project_links_with_changesets.patch to use the cross-project wiki formats (project:r1234 and

project:commit:ab34cd) when fixing issues via repository commit keywords.

#13 - 2010-08-06 14:27 - Pieter Smith

By the way... 100805-1.0.0_r3854-cross-project_redmine_links.patch doesn't play well with 0.9.6. The trouble starts with:

text = text.gsub (%r{ ([\s\(,\=\>]1") (!)? (attachment |document |version|commit |source|export |message)? ((#|r) (\d+) |
() ([""\s<>] ["\s<>]*2|"[""]+2")) (?=(?=[[:punct:]1]1\W) |, [\s[<|$)}) do [m]|

in 0.9.6 versus the expected

text.gsub! ($r{ ([\s\ (, \=\[\>1]") (!)? (attachment |document | version|commit | source |export |message|project)? ((#|xr) (\
d+) | (2) ([""\s<>][M\s<>]*2|"[""]+2")) (?=(?=[[:punct:1]1\W) |, [\sI\]I<[$)}) do

which is what the patch expects.

#14 - 2011-01-20 03:56 - Blake Williams

Subprojects in Redmine are effectively useless without this feature.

#15 - 2011-03-24 12:34 - Toshi MARUYAMA

- Category set to Text formatting

#16 - 2012-09-22 14:41 - Stefan Lindner

Still no plans to include this in near future? Wikis look awful without th ability to display a homan readable text for repository links.

#17 - 2012-10-23 13:59 - Sébastien Aubry

The syntax: [[project:page|text]] should indeed work. It is even weird that it is not the case by default. Probably a problem with the regexp?

#18 - 2013-03-05 05:15 - Thomas Robbs

+1

#19 - 2014-03-21 08:53 - Arthur Zalevsky

Yep, it's definitely necessary feature.

#20 - 2014-04-20 01:00 - Toshi MARUYAMA

- Related to Defect #3483: Relative url for source links in notifications added

#21 - 2014-09-24 16:00 - Toshi MARUYAMA

- Related to Feature #10248: Specific text instead of addresses to the Redmine internal links added

#22 - 2016-01-01 07:26 - Toshi MARUYAMA

- Related to Feature #21443: Links to resources in Markdown added

#23 - 2016-02-04 19:10 - Hans Ginzel

Please, also for Markdown formatting, #15520.
